// CERC 2012
// Problem J: Conservation
// Model solution.
// Author: Adam Polak

#include <algorithm>
#include <cstdio>
#include <queue>
#include <vector>
using namespace std;

const int N = 100000;

int n, col[N], d[N];
vector<int> g[N];

int compute(int lab) {
  queue<int> q[2];
  for (int i=0; i<n; ++i)
    d[i] = 0;
  for (int i=0; i<n; ++i)
    for (int j=0; j<g[i].size(); ++j)
      d[g[i][j]]++;
  for (int i=0; i<n; ++i)
    if (d[i]==0)
      q[col[i]].push(i);
  int result = 0;
  while (q[0].size() + q[1].size() > 0) {
    if (q[lab].empty()) {
      lab = 1 - lab;
      result++;
    }
    int u = q[lab].front();
    q[lab].pop();
    for (int i=0; i<g[u].size(); ++i) {
      int v = g[u][i];
      d[v]--;
      if (d[v]==0)
        q[col[v]].push(v);
    }
  }
  return result;
}

int main() {
  int Z;
  scanf("%d", &Z);
  while (Z--) {
    int m;
    scanf("%d%d", &n, &m);
    for (int i=0; i<n; ++i) {
      scanf("%d", &col[i]);
      col[i]--;
    }
    for (int i=0; i<m; ++i) {
      int a, b;
      scanf("%d%d", &a, &b);
      g[a-1].push_back(b-1);
    }
    printf("%d\n", min(compute(0), compute(1)));
    for (int i=0; i<n; ++i) {
      vector<int> temp;
      g[i].swap(temp);
    }
  }
  return 0;
}

